// Copyright 2017 SiegeLord
// Licensed under GPL, see LICENSE for full terms

use engine::world::WorldState;
use engine::id_map::HasId;

pub struct ParentLogic;

complex_behavior!
{
	ParentLogic[true] |self, _obj, objs, state|
	{
		let mut old_ids_to_remove = vec![];
		old_ids_to_remove.extend(state.get_ids_to_remove().iter());
		let mut new_ids_to_remove = vec![];
		while !old_ids_to_remove.is_empty()
		{
			new_ids_to_remove.clear();
			for obj in objs.elems()
			{
				let obj = obj.borrow();
				for &dead_id in &old_ids_to_remove
				{
					if obj.parent == dead_id
					{
						state.remove_object(obj.get_id());
						new_ids_to_remove.push(obj.get_id());
					}
				}
			}
			old_ids_to_remove.clear();
			old_ids_to_remove.extend(&new_ids_to_remove);
		}
		
		state.get_ids_to_remove().reverse();
	}
}
